; Event Mask Constants
#EM_REDRAW = $01
#EM_KEY    = $02
#EM_BUTTON = $04
#EM_MOUSE  = $20

; Window Style Constants
#WS_SKINNED_FIXED    = $04000000
#WS_SKINNED_SIZABLE  = $03000000
#WS_FIXED            = $00000000
#WS_SIZABLE          = $02000000
#WS_FILL_TRANSPARENT = $40000000
#WS_FILL_GRADIENT    = $80000000
#WS_COORD_CLIENT     = $20000000
#WS_CAPTION          = $10000000

; Caption styles
#CAPTION_MOVABLE    = $00000000
#CAPTION_NONMOVABLE = $01000000

Procedure DrawWindow(left, width, top, height, style, caption, capstyle)
  EnableASM
        ;push   ebx
        ;push   edi
        ;push   esi
        xor    eax, eax
        mov    ebx, left
        shl    ebx, 16
        or     ebx, width
        mov    ecx, top
        shl    ecx, 16
        or     ecx, height
        mov    edx, style
        mov    edi, caption
        mov    esi, capstyle
        int    64
        ;pop    esi
        ;pop    edi
        ;pop    ebx
  DisableASM
EndProcedure

Procedure RedrawStart()
  EnableASM
        push   ebx
        mov    eax, 12
        mov    ebx, 1
        int    64
        pop    ebx
  DisableASM
EndProcedure

Procedure RedrawFinish()
  EnableASM
        push   ebx
        mov    eax, 12
        mov    ebx, 2
        int    64
        pop    ebx
  DisableASM
EndProcedure

Procedure.l WaitEvent()
  EnableASM
        mov    eax, 10
        int    64
        ProcedureReturn
  DisableASM
EndProcedure

Procedure SetEventMask(mask)
  EnableASM
        ;push   ebx
        mov    eax, 40
        mov    ebx, mask
        int    64
        ;pop    ebx
  DisableASM
EndProcedure

Procedure.l GetScreenSize()
  EnableASM
        push   ebx
        mov    eax, 61
        mov    ebx, 1
        int    64
        pop    ebx
        ProcedureReturn
  DisableASM
EndProcedure

#MY_WIN_STYLE  = #WS_CAPTION | #WS_COORD_CLIENT | #WS_SKINNED_SIZABLE | #WS_FILL_GRADIENT | $001155DD
#MY_EVENT_MASK = #EM_REDRAW | #EM_BUTTON

Define.l Width, Height, Left, Top
Define.l tmp1, tmp2

SetEventMask(#MY_EVENT_MASK)

; calculate left, top, width, height:
tmp1 = GetScreenSize()
tmp2 = tmp1
tmp1 >> 17
tmp2 & $FFFF
tmp2 >> 1
Height = tmp2
tmp2 >> 1
Top  = tmp2
Width = tmp1
tmp1 >> 1
Left = tmp1

Repeat
  RedrawStart()
  DrawWindow(Left, Width, Top, Height, #MY_WIN_STYLE, 0, #CAPTION_MOVABLE)
  RedrawFinish()
Until WaitEvent() <> 1
